#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

int **creer_matrice(int n, int m) {
  int **p = (int**)malloc(sizeof(int*) * n);
  for (int i = 0; i < n; i++) {
    p[i] = malloc(sizeof(int) * m);
  }
  return p;
}
                                               
void detruire_matrice(int **p, int n, int m) {
  for (int i = 0; i < n; i++) {
    free(p[i]);
  }
  free(p);
}

int min2(int a, int b)
{
  if (a < b) { return a; }
  else { return b; }
}

int min3(int a, int b, int c)
{
  return (min2(min2(a,b), c));
}

int levenshtein(char *u, char *v)
{
  int lu = strlen(u);
  int lv = strlen(v);
  int **d = creer_matrice(lu+1, lv+1);
  for (int i = 0; i <= lu; i++) { d[i][0] = i; } // Première ligne
  for (int j = 1; j <= lv; j++) { d[0][j] = j; } // Première colonne
  for (int i = 1; i <= lu; i++) {
    for (int j = 1; j <= lv; j++) {
      int d1 = d[i-1][j] + 1;
      int d2 = d[i][j-1] + 1;
      int d3 = d[i-1][j-1];
      if (u[i-1] != v[j-1]) { d3++; }
      d[i][j] = min3(d1, d2, d3);
    }
  }
  int r = d[lu][lv];
  detruire_matrice(d, lu+1, lv+1);
  return r;
}

int main()
{
  printf("%d\n", levenshtein("niche", "chiens"));
}
