#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

struct result {
  int *t;
  int size;
};
typedef struct result result;

result monnaie_glouton(int n, int p[n], int x)
{
  int *t = (int*)malloc(sizeof(int) * x);
  int monnaie = x;
  int i = n-1;
  int nb_pieces = 0;
  while (monnaie > 0)
  {
    if (monnaie >= p[i])
    {
      monnaie -= p[i];
      nb_pieces++;
      t[x-nb_pieces] = p[i];
    }
    else
    {
      i--;
    }
  }
  result res = {&t[x-nb_pieces], nb_pieces};
  return res;
}

/* Programmation dynamique */

int **creer_matrice(int n, int m) {
  int **p = (int**)malloc(sizeof(int*) * n);
  for (int i = 0; i < n; i++) {
    p[i] = malloc(sizeof(int) * m);
  }
  return p;
}
                                               
void detruire_matrice(int **p, int n, int m) {
  for (int i = 0; i < n; i++) {
    free(p[i]);
  }
  free(p);
}

int min(int a, int b)
{
  if (a < b) { return a; }
  else { return b; }
}

result monnaie_dyna(int n, int p[n], int x)
{
  int **s = creer_matrice(n, x+1);
  for (int i = 0; i < n; i++) {
    s[i][0] = 0; // Il faut 0 pièces pour rendre 0
  }
  for (int k = 1; k <= x; k++) { // Première ligne
    if (k-p[0] >= 0) { s[0][k] = 1 + s[0][k-p[0]]; }
    else { s[0][k] = 32767; } // max_int
  }
  for (int i = 1; i < n; i++) {
    for (int k = 1; k <= x; k++) {
      if (k-p[i]<0) { s[i][k] = s[i-1][k]; }
      else { s[i][k] = min(1 + s[i][k-p[i]], s[i-1][k]); }
    }
  }
  int *t = (int*)malloc(sizeof(int) * x);
  int k = x;
  int i = n-1;
  int nb_pieces = 0;
  while (k > 0) {
    int k2 = k-p[i];
    if (k2 < 0) { i--; }
    else if (i == 0) {
      k = k2;
      nb_pieces++;
      t[x-nb_pieces] = p[i];
    }
    else if (s[i-1][k] < 1 + s[i][k2]) { i--; }
    else {
      k = k2;
      nb_pieces++;
      t[x-nb_pieces] = p[i];
    }
  }
  result res = {&t[x-nb_pieces], nb_pieces};
  detruire_matrice(s, n, x+1);
  return res;
}

int main()
{
  printf("Exemple glouton :\n");
  int p[] = {1, 2, 5, 10, 20, 50};
  result res = monnaie_glouton(6, p, 139);
  printf("pièces : ");
  for (int i = 0; i < res.size; i++)
  {
    printf("%d ", res.t[i]);
  }
  printf("\nnombre de pièces : %d\n", res.size);
  printf("Exemple dynamique :\n");
  int p2[] = {1, 3, 4};
  result res2 = monnaie_dyna(3, p2, 6);
  printf("pièces : ");
  for (int i = 0; i < res2.size; i++)
  {
    printf("%d ", res2.t[i]);
  }
  printf("\nnombre de pièces : %d\n", res2.size);
}
